#include "stdlib.h"
#include "config.h"
#include "functions.h"
// Set your serial port baud rate used to send out data here!
#define OUTPUT__BAUD_RATE 115200
#define STATUS_LED_PIN 13  // Pin number of status LED
//#define TO_DEG(x) (x * 57.2957795131)  // *180/pi

char temp_str[8];
char temp_str_count, data_count,temp_read; 
double yaw,pitch,roll; // данные в градусах!!!
// Start values - center position for head tracker
float tiltStart = 0;
float panStart = 0;
float rollStart = 0;
float temp = 0;
char TrackerStarted = 0;

// Servo reversing
char tiltInverse = -1;
char rollInverse = -1;
char panInverse = -1;


// Settings
int servoPanCenter = 2100;
int servoTiltCenter = 2100;
int servoRollCenter = 2100;
int panMaxPulse = 1150;
int panMinPulse = 1150;
int tiltMaxPulse = 1150;
int tiltMinPulse = 1150;
int rollMaxPulse = 1150;
int rollMinPulse = 1150;
float panFactor = 17;
float tiltFactor = 17;
float rollFactor = 17;
unsigned char servoReverseMask = 0;
unsigned char htChannels[3] = {8, 7, 6}; // pan, tilt, roll
extern long channel_value[];
char lastButtonState = 0;           // 0 is not pressed, 1 is pressed
void setup()
{
  // Init serial output
  Serial.begin(OUTPUT__BAUD_RATE);
  
  // Init status LED

    pinMode(BUTTON_INPUT,INPUT);
    // Set internal pull-up resistor. 
    digitalWrite(BUTTON_INPUT,HIGH);
  // Init status LED
  pinMode (STATUS_LED_PIN, OUTPUT);
  digitalWrite(STATUS_LED_PIN, LOW);  
  pinMode(9,OUTPUT); // PPM out
   InitPWMInterrupt();         // Start PWM interrupt 

  delay(200);  // Give sensors enough time to start
}


// Main loop
void loop()
{
/**/  // Read incoming control messages
  if (Serial.available()) 
  {
    temp_read=Serial.read();
    if (temp_read == '=') // Start of new control message
    {
     temp_str_count=0;
    data_count=0; 
    }
    else {
      if ((temp_read==',')||(temp_read==0x0d))
      {
      temp_str[temp_str_count]=0;
      if (data_count==0) yaw=atof(temp_str);
      if (data_count==1) pitch=atof(temp_str);
      if (data_count==2) roll=atof(temp_str);
//      Serial.println(data_count);
      data_count++;
      temp_str_count=0;
      }
      else  if (temp_str_count<8) temp_str[temp_str_count++]=temp_read;
    
    }
      if (temp_read==0x0D){
 /*         Serial.print("str ");Serial.println(temp_str);
          temp_float=atof(temp_str);
          Serial.print("float ");Serial.println(temp_float+.1);*/
                  // Check input button for reset/pause request
    char buttonPressed = (digitalRead(BUTTON_INPUT) == 0);
        // проверка нажатия кнопки и центровка
    if (( buttonPressed && lastButtonState == 0)||(TrackerStarted==0))
    {
        lastButtonState = 1;
        panStart=yaw;
        tiltStart=pitch;
        rollStart=roll;
        TrackerStarted=1;
    }
    if ( !buttonPressed ) lastButtonState = 0;

      //********************************************************
      // calculate chanel data
        temp = yaw-panStart;
        if  (temp > 180) temp -= 360; 
        else if (temp < -180) temp += 360; 
        temp = temp * panInverse * panFactor;
        if ((temp > -panMinPulse) && (temp < panMaxPulse) ) channel_value[htChannels[0]] = (int)(servoPanCenter +temp);
       
        temp = ((pitch - tiltStart) * tiltInverse * tiltFactor);
        if ((temp > -panMinPulse) && (temp < panMaxPulse)) channel_value[htChannels[1]] = (int)(servoTiltCenter +temp);

        temp = roll - rollStart;
        if  (temp > 180) temp -= 360; 
        else if (temp < -180) temp += 360;
        temp = temp * rollInverse * rollFactor;        
        if ( (temp > -panMinPulse) && (temp < panMaxPulse) ) channel_value[htChannels[2]] =(int) (servoRollCenter +temp);
        /* вывод серво
        Serial.print((channel_value[htChannels[0]])); Serial.print(",");
        Serial.print((channel_value[htChannels[1]])); Serial.print(",");
        Serial.println((channel_value[htChannels[2]]));
        */
  }
  }

          
}
